unit Dynamain;

{ This unit demonstrates the use of class references to dynamically
  instantiate components. }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Menus,unit3, Buttons, TabNotBk,unit2;

type  TForm1 = class(TForm)
    procedure Button1Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
        procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure ButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
          procedure ButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    procedure wmcommand(var Msg : TWMcommand); message wm_command;
{    procedure wmlbuttondown(var Msg : TWMlbuttondown); message wm_lbuttondown;
    procedure wmlbuttonup(var Msg : TWMlbuttonup); message wm_lbuttonup;
    procedure wmmousemove(var Msg : TWMmousemove); message wm_mousemove; }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  xx,xy,xd:longint;
  fmd,fwday,fwdax,wax,way,wd,rwa,lwa,twa,bwa:longint;
var selecteditem:integer;

implementation

{$R *.DFM}

{ In the form's OnCreate method, we fill the combo box with a list
  of class names, each accompanied by an actual class reference
  (stored in Items.Objects).  }


  function additem(a:byte):string; begin end;
  function deleteitem(a:byte):string;begin end;
  function setitem(a:byte):string; begin end;
  function getitem(a:byte):string; begin end;


    function start(item:longint):byte; begin
   form3.sg.cells[0,0]:='parent';
   form3.sg.cells[0,1]:='left';
   form3.sg.cells[0,2]:='top';
   form3.sg.cells[0,3]:='width';
   form3.sg.cells[0,4]:='height';
   form3.sg.cells[0,5]:='text';
   form3.sg.cells[0,6]:='color';
   form3.sg.cells[0,7]:='name';


   form3.stringgrid1.cells[0,0]:='WM_LBUTTONUP';
   form3.stringgrid1.cells[0,1]:='WM_LBUTTONDOWN';
   form3.stringgrid1.cells[0,2]:='WM_MOUSEMOVE';
   form3.stringgrid1.cells[0,3]:='WM_KEYUP';
   form3.stringgrid1.cells[0,4]:='WM_KEYDOWN';

  end;

  function clear(item:longint):byte; begin
   form3.sg.cells[1,0]:='';
   form3.sg.cells[1,1]:='';
   form3.sg.cells[1,2]:='';
   form3.sg.cells[1,3]:='';
   form3.sg.cells[1,4]:='';
   form3.sg.cells[1,5]:='';
   form3.sg.cells[1,6]:='';
   form3.sg.cells[1,7]:='';
   form3.sg.cells[1,8]:='';
   form3.sg.cells[1,9]:='';
  end;


  function selectitem(item:longint):byte;
  vAR Instance: TControl;
    var Text: array[0..255] of Char;
    cc: TControlClass;
  var te,sto:longint;
  var oo:word;
  pc:pchar;
  begin
  pc:='                                                                                  '+
'                                                                                      ';
     oo:=100;
   Instance := findcontrol(item);
   form3.combobox1.text:=inttostr(item);
   form3.sg.cells[1,0]:=inttostr(form1.handle);
   form3.sg.cells[1,1]:=inttostr(instance.left);
   form3.sg.cells[1,2]:=inttostr(instance.top);
   form3.sg.cells[1,3]:=inttostr(instance.width);
   form3.sg.cells[1,4]:=inttostr(instance.height);
      if Instance is TWinControl then
    sendMessage(TWinControl(Instance).Handle, WM_GETTEXT,oo,Longint(@Text));
   form3.sg.cells[1,5]:=strpas(@text);
     form3.sg.cells[1,6]:=colortostring(tedit(instance).color);
    form3.sg.cells[1,7]:=el.values[inttostr(item)+','+form3.sg.cells[0,7]];


   form3.stringgrid1.cells[1,0]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,0]];
   form3.stringgrid1.cells[1,1]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,1]];
   form3.stringgrid1.cells[1,2]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,2]];
   form3.stringgrid1.cells[1,3]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,3]];
   form3.stringgrid1.cells[1,4]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,4]];
   form3.stringgrid1.cells[1,5]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,5]];
   form3.stringgrid1.cells[1,6]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,6]];
   form3.stringgrid1.cells[1,7]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,7]];
   form3.stringgrid1.cells[1,8]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,8]];
   form3.stringgrid1.cells[1,9]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,9]];
   form3.stringgrid1.cells[1,10]:=el.values[inttostr(item)+','+form3.stringgrid1.cells[0,10]];


  end;


  procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin


if(msg.message=WM_KILLFOCUS)then begin form1.color:=clred; end else begin end;
end;

  procedure tform1.wmcommand(var Msg : TWMcommand);
    var Text: array[0..255] of Char;
    Reference: TControlClass;
    Instance: TControl;
      begin
    if(xd=0)then begin
  {  caption:=inttostr(msg.itemid); }
    selecteditem:=msg.itemid;
    selectitem(msg.itemid);
    Instance := findcontrol(msg.itemid);

   end;
   end;

{ When the Create button is pressed, we fetch the class reference from
  the currently selected itm in the combo box.  We can then create an
  actual instance of whatever class the reference points to by calling its
  constructor.  We then parent the new instance to a panel, and position it
  according to the values in the edit boxes.

  Lastly, we send a WM_SETTEXT message to the control (as long as it is a
  TWinControl) and allow the control to handle the message however it wants.
  (Some controls have a Caption property, while others have a Text property.
  Sending a WM_SETTEXT message avoids having to know which property the new
  instance has.)  }

procedure TForm1.Button1Click(Sender: TObject);
var
  Reference: TControlClass;
  Instance: TControl;
  Text: array[0..255] of Char;
begin
  Reference := TControlClass(tabbeddlg.ClassList.Items.Objects[tabbeddlg.ClassList.ItemIndex]);

  Instance := Reference.Create(form1);
  Instance.Parent := form1;
  Instance.Left := 111;
  Instance.Top := 133;

  if Instance is TWinControl then
    SendMessage(TWinControl(Instance).Handle, WM_SETTEXT, 0,
      Longint(StrPCopy(Text, tabbeddlg.ClassList.Text)));


end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Reference: TControlClass;
  Instance: TControl;
  Text: array[0..255] of Char;
begin
fmd:=0;

if(tabbeddlg.classlist.itemindex>0)then begin
  Reference := TControlClass(tabbeddlg.ClassList.Items.Objects[tabbeddlg.ClassList.ItemIndex]);

  Instance := Reference.Create(self);
  Instance.Parent := form1;
  Instance.Left := x;
  Instance.Top := y;
      selecteditem:=TWinControl(Instance).Handle;
  if Instance is TWinControl then
    SendMessage(TWinControl(Instance).Handle, WM_SETTEXT, 0,
      Longint(StrPCopy(Text, tabbeddlg.ClassList.Text)));
      selectitem(TWinControl(Instance).Handle);


      if(instance is tbutton)then begin
           tbutton(instance).Onmouseup:=ButtonMouseUp;
           tbutton(instance).Onmousedown:=ButtonMousedown;
           tbutton(instance).Onmousemove:=ButtonMouseMove; end;
           if(instance is tedit)then begin
           tedit(instance).Onmouseup:=ButtonMouseUp;
           tedit(instance).Onmousedown:=ButtonMousedown;
           tedit(instance).Onmousemove:=ButtonMouseMove;
           end;
           if(instance is tlistbox)then begin
              tlistbox(instance).Onmouseup:=ButtonMouseUp;
           tlistbox(instance).Onmousedown:=ButtonMousedown;
           tlistbox(instance).Onmousemove:=ButtonMouseMove;

           end;
           if(instance is tcheckbox)then begin
             tcheckbox(instance).Onmouseup:=ButtonMouseUp;
           tcheckbox(instance).Onmousedown:=ButtonMousedown;
           tcheckbox(instance).Onmousemove:=ButtonMouseMove;
           end;
           if(instance is tradiobutton)then begin
           tradiobutton(instance).Onmouseup:=ButtonMouseUp;
           tradiobutton(instance).Onmousedown:=ButtonMousedown;
           tradiobutton(instance).Onmousemove:=ButtonMouseMove;
           end;

 



end else begin
selecteditem:=0;

end;
  tabbeddlg.classlist.itemindex:=0;
 xd:=0;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
    var Instance: TControl;
    begin
{SPACE}
if(key=32)then begin
{ caption:=inttostr(form1.componentcount);}end;
{SHIFT}
if(key=16)then begin end;
{DELETE}
if(key=46)then begin
if(selecteditem>0)then begin
Instance := findcontrol(selecteditem);
         if(instance is tbutton)then begin
         form1.removecontrol((instance));
         form1.removecomponent(tbutton(instance));
         selecteditem:=0;clear(selecteditem);end;
         if(instance is tedit)then begin
         form1.removecontrol((instance));
         form1.removecomponent(tedit(instance));selecteditem:=0;clear(selecteditem);end;
         if(instance is tlistbox)then begin
         form1.removecontrol((instance));
         form1.removecomponent(tlistbox(instance));
          selecteditem:=0;clear(selecteditem);end;
         if(instance is tcheckbox)then begin
         form1.removecontrol((instance));
         form1.removecomponent(tcheckbox(instance));
         selecteditem:=0;clear(selecteditem);end;
         if(instance is tradiobutton)then begin
         form1.removecontrol((instance));
         form1.removecomponent(tradiobutton(instance));
         selecteditem:=0;clear(selecteditem);end;
         end;
end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
start(1);
selecteditem:=form1.handle;
    selectitem(form1.handle);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
      var cp:tpoint;
begin

fmd:=1;      getcursorpos(cp);
xd:=1;
fwdax:=cp.x-left;
fwday:=cp.y-top;
selecteditem:=form1.handle;
    selectitem(form1.handle);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
    var cp:tpoint;
begin

 xx:=x;xy:=y;
          getcursorpos(cp);
  if(shift=[ssLeft])and(fmd=1)and(selecteditem=form1.handle)then begin
   left:=cp.x-(fwdax);
     top:=cp.y-(fwday);
  end;

  if(shift=[ssLeft])and(fmd=0)and(not(selecteditem=form1.handle))then begin

     ButtonMouseMove(findcontrol(strtoint(form3.combobox1.text)),Shift,X,Y);

  end;

end;

procedure TForm1.ButtonMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
wd:=0;
end;
procedure TForm1.ButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var cp:tpoint;
  Instance: TControl;
begin
     {this}
      getcursorpos(cp);
          instance:=tcontrol(sender);
     if(xd=0)then begin
     selecteditem:=findcontrol(twincontrol(instance).handle).handle;
    selectitem(findcontrol(twincontrol(instance).handle).handle);
   instance:=tcontrol(sender);
      end;
     wd:=1;   wax:=x;way:=y;

    if(instance is TWinControl)then begin
tbutton(instance).cursor:=crdefault;
    if(x<4)then begin  wd:=2;lwa:=form1.left+tbutton(instance).left+TWinControl(instance).width;end else begin   end;
    if(x>TWinControl(Instance).width-4)then begin wd:=3;end else begin    end;
    if(y<4)then begin wd:=4;twa:=form1.top+TWinControl(instance).top+TWinControl(instance).height;end else begin  end;
    if(y>TWinControl(Instance).height-4)then begin wd:=5;end else begin   end;
end;


end;

procedure TForm1.ButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var cp:tpoint;
   Instance: TControl;
   var wr:trect;
   adj,os:byte;
begin
adj:=4;
 instance:=findcontrol(strtoint(form3.combobox1.text));
        if(findcontrol(strtoint(form3.combobox1.text))=instance)then begin
       getcursorpos(cp);
       os:=0;
       cp.x:=cp.x-os;
       cp.y:=cp.y-os;
       
if(instance is TWinControl)then begin
TWinControl(instance).cursor:=crdefault;
    if(x<adj)then begin  TWinControl(instance).cursor:=crsizewe;end else begin   end;
    if(x>TWinControl(Instance).width-adj)then begin TWinControl(instance).cursor:=crsizewe;end else begin    end;
    if(y<adj)then begin TWinControl(instance).cursor:=crsizens;end else begin  end;
    if(y>TWinControl(Instance).height-adj)then begin TWinControl(instance).cursor:=crsizens;end else begin   end;
end;
  if(shift=[ssLeft])then begin


    if(wd=1)then begin     {right}
     instance.left:=(cp.x-form1.left-wax);
    form3.sg.cells[1,1]:=inttostr(instance.left);
    instance.top:=cp.y-form1.top-way-(form1.clientorigin.y-form1.top);
   form3.sg.cells[1,2]:=inttostr(instance.top);
   end;

      if(wd=2)then begin    {left}
     instance.left:=cp.x-form1.left;
    form3.sg.cells[1,1]:=inttostr(instance.left);
         instance.width:=lwa-cp.x;
      form3.sg.cells[1,2]:=inttostr(instance.width);

   end;

         if(wd=3)then begin {bottom}
             instance.width:=cp.x-form1.left-instance.left-2;
      form3.sg.cells[1,3]:=inttostr(instance.width);
      end;

      if(wd=4)then begin    {top}
      instance.top:=cp.y-form1.top-(form1.clientorigin.y-form1.top);
      form3.sg.cells[1,2]:=inttostr(instance.top);
      instance.height:=(twa-cp.y)+(form1.clientorigin.y-form1.top);
      form3.sg.cells[1,4]:=inttostr(instance.height);
      end;


               if(wd=5)then begin
             instance.height:=(y)+2;
      form3.sg.cells[1,4]:=inttostr(instance.height);
      end;

  end;
end;
end;
procedure TForm1.FormResize(Sender: TObject);
begin
selecteditem:=form1.handle;
    selectitem(form1.handle);
end;

end.
