unit Unit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, Menus,shellapi,unit3,unit4;

type
  TTabbedDlg = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    MainMenu1: TMainMenu;
    saveproject1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    classlist: TComboBox;
    html1: TMenuItem;
    profans: TMenuItem;
    svstp1: TMenuItem;
    delphi3: TMenuItem;
    watcom: TMenuItem;
    Virtualpascal1: TMenuItem;
    Devpascal1: TMenuItem;
    POW321: TMenuItem;
    xblite1: TMenuItem;
    file321: TMenuItem;
    interpreted1: TMenuItem;
    fasm1: TMenuItem;
    msvc1: TMenuItem;
    tpw1: TMenuItem;
    msvc2: TMenuItem;
    BorlandC551: TMenuItem;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure openproject1Click(Sender: TObject);
    procedure saveproject1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure html1Click(Sender: TObject);
    procedure profansClick(Sender: TObject);
    procedure svstp1Click(Sender: TObject);
    procedure delphi3Click(Sender: TObject);
    procedure watcomClick(Sender: TObject);
    procedure Devpascal1Click(Sender: TObject);
    procedure POW321Click(Sender: TObject);
    procedure xblite1Click(Sender: TObject);
    procedure Virtualpascal1Click(Sender: TObject);
    procedure fasmw1Click(Sender: TObject);
    procedure msvc1Click(Sender: TObject);
    procedure tpw1Click(Sender: TObject);
    procedure msvc2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TabbedDlg: TTabbedDlg;

implementation

{$R *.DFM}

procedure TTabbedDlg.SpeedButton1Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('tedit');
end;

procedure TTabbedDlg.SpeedButton2Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('tcheckbox');
end;

procedure TTabbedDlg.SpeedButton3Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('tradiobutton');
end;

procedure TTabbedDlg.SpeedButton4Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('tbutton');
end;

procedure TTabbedDlg.SpeedButton5Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('tlistbox');
end;

procedure TTabbedDlg.SpeedButton6Click(Sender: TObject);
begin
classlist.itemindex:=classlist.items.indexof('');
end;

procedure TTabbedDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
application.terminate;
end;

procedure TTabbedDlg.openproject1Click(Sender: TObject);
begin
  opendialog.execute;
end;
        function StrToPChar(const Str: string): PChar;
begin
  { Allocate a PChar and copy the original string. }
  Result := StrAlloc(Length(Str)+1);
  StrPCopy(Result, Str);
end;

function righto(stringon,seperaton:string):string; begin
result:=copy(stringon,pos(seperaton,stringon)+1,length(stringon));
end;

function lefto(stringo,seperato:string):string; begin
result:=copy(stringo,0,pos(seperato,stringo)-1);
end;
procedure TTabbedDlg.saveproject1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=2;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
                           showmessage('pow16');
if(extractfileext(savedialog.filename)='.MOD')then begin
comp:=application.mainform.componentcount;
a:=0;
sl.add('MODULE '+lefto((extractfilename(savedialog.filename)),'.')+';');
sl.add('IMPORT W:=Windows,SYSTEM;');
sl.add('CONST');
sl.add('txt1="menu";');
sl.add('txt2="window";');
sl.add('txt4="'+application.mainform.caption+'";');
sl.add('VAR hInst: W.HANDLE;');
sl.add('PROCEDURE [WINDOWS] MainWndProc*(hWnd: W.HWND;message: W.WORD;wParam: W.WORD;lParam: LONGINT): LONGINT; BEGIN');
sl.add('IF message = W.WM_DESTROY THEN ');
sl.add('W.PostQuitMessage(0) ELSE  RETURN W.DefWindowProc(hWnd, message, wParam, lParam) END;');
sl.add(' RETURN W.NULL END MainWndProc;');
sl.add('PROCEDURE [WINDOWS] WinMain*(');
sl.add('hInstance: W.HANDLE;hPrevInstance: W.HANDLE;lpCmdLine: W.LPSTR;nCmdShow: INTEGER): INTEGER;');
sl.add('  VAR r: LONGINT; msg: W.MSG;');
sl.add('VAR');
sl.add('wc: W.WNDCLASS;');
sl.add('hWnd: W.HWND;');
{add component handles vars}
a:=0;
while (a<comp) do begin
sl.add('hWnd'+inttostr(a)+': W.HWND;');
a:=a+1;
end;
sl.add('BEGIN');
sl.add('wc.style := W.NULL;wc.lpfnWndProc := MainWndProc;wc.cbClsExtra := 0;wc.cbWndExtra := 0;');
sl.add('wc.hInstance := hInstance; wc.hCursor := W.LoadCursor(W.NULL, W.IDC_ARROW);');
{sl.add('wc.hbrBackground := W.GetStockObject(W.BLACK_BRUSH);');}
sl.add('wc.hbrBackground := 6;');
sl.add('wc.lpszMenuName := W.NULL;');
sl.add('wc.lpszClassName := SYSTEM.ADR(txt2);');
sl.add('IF hPrevInstance = 0 THEN IF W.RegisterClass(SYSTEM.ADR(wc))=0 THEN RETURN W.false; END;END;');
sl.add('hInst := hInstance;');

sl.add('hWnd := W.CreateWindow(');
sl.add('SYSTEM.ADR(txt2),');
sl.add('SYSTEM.ADR(txt4),');
sl.add('W.WS_OVERLAPPEDWINDOW,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('W.NULL,W.NULL,');
sl.add('hInstance,');
sl.add('W.NULL);');
{add component windows}
a:=0;
while (a<comp) do begin
sl.add('hWnd'+inttostr(a)+':= W.CreateWindow(');
{tbutton}
if(application.mainform.components[a] is tbutton)then begin
sl.add('SYSTEM.ADR("button"),');
sl.add('SYSTEM.ADR("'+tbutton(application.mainform.components[a]).caption+'"),');
sl.add('W.WS_VISIBLE+W.WS_CHILD+W.BS_PUSHBUTTON,');
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,2,hInstance,W.NULL);');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add('SYSTEM.ADR("edit"),');
sl.add('SYSTEM.ADR("'+tbutton(application.mainform.components[a]).caption+'"),');
sl.add('W.WS_VISIBLE+W.WS_CHILD+W.ES_LEFT+W.WS_BORDER,');
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,2,hInstance,W.NULL);');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add('SYSTEM.ADR("button"),');
sl.add('SYSTEM.ADR("'+tbutton(application.mainform.components[a]).caption+'"),');
sl.add('W.WS_VISIBLE+W.WS_CHILD+W.BS_CHECKBOX,');
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,2,hInstance,W.NULL);');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add('SYSTEM.ADR("button"),');
sl.add('SYSTEM.ADR("'+tbutton(application.mainform.components[a]).caption+'"),');
sl.add('W.WS_VISIBLE+W.WS_CHILD+W.BS_RADIOBUTTON,');
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,2,hInstance,W.NULL);');
end else

if(application.mainform.components[a] is tlistbox)then begin
sl.add('SYSTEM.ADR("listbox"),');
sl.add('SYSTEM.ADR("'+tbutton(application.mainform.components[a]).caption+'"),');
sl.add('W.WS_VISIBLE+W.WS_CHILD+W.LBS_HASSTRINGS+W.WS_BORDER,');
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,2,hInstance,W.NULL);');

end;



a:=a+1;
end;


sl.add('r:=W.ShowWindow(hWnd, nCmdShow);');
sl.add('WHILE W.GetMessage(SYSTEM.ADR(msg),W.NULL,W.NULL,W.NULL) # 0 DO');
a:=0;
while a<comp do begin
sl.add('IF(msg.hwnd=hWnd'+inttostr(a)+')THEN');
sl.add('IF(msg.message=W.WM_LBUTTONUP)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('END;');
sl.add('IF(msg.message=W.WM_LBUTTONDOWN)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('END;');
sl.add('IF(msg.message=W.WM_KEYUP)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('END;');
sl.add('IF(msg.message=W.WM_KEYDOWN)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('END;');
sl.add('IF(msg.message=W.WM_MOUSEMOVE)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('END;');




sl.add('END;');
a:=a+1;
end;
sl.add(' r := W.TranslateMessage(SYSTEM.ADR(msg));r := W.DispatchMessage(SYSTEM.ADR(msg));');
sl.add('END; RETURN msg.wParam END WinMain;');
sl.add('END '+lefto((extractfilename(savedialog.filename)),'.')+'.');


if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;


end;



end;
sl.free;
end;





procedure TTabbedDlg.FormCreate(Sender: TObject);
        begin
  with ClassList.Items do
  begin
    AddObject('', nil);
     AddObject('TEdit', TObject(TEdit));
    AddObject('TCheckBox', TObject(TCheckBox));
    AddObject('TRadioButton', TObject(TRadioButton));
    AddObject('TButton', TObject(TButton));
    AddObject('TListBox', TObject(TListBox));
   

  end;
  ClassList.ItemIndex := 0;

end;

procedure TTabbedDlg.html1Click(Sender: TObject);
var comp:longint;
a:longint;
sl:tstringlist;
begin
savedialog.filterindex:=4;
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin

if(extractfileext(savedialog.filename)='.HTM')then begin
html(sl);

if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;
end;
sl.free;
end;




end;

procedure TTabbedDlg.profansClick(Sender: TObject);
var comp:longint;
a:longint;
sl:tstringlist;
begin
savedialog.filterindex:=6;
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.PRF')then begin
comp:=application.mainform.componentcount;
a:=0;
profan(sl,el,comp);
if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;
end;
end;


sl.free;
end;

procedure TTabbedDlg.svstp1Click(Sender: TObject);
var comp:longint;
a:longint;
sl:tstringlist;
begin
savedialog.filterindex:=5;
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
 if(extractfileext(savedialog.filename)='.TFS')then begin
tfs(sl,el);
if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);

ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;
end;
end;
sl.free;
end;

procedure TTabbedDlg.delphi3Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=7;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.DPR')then begin
comp:=application.mainform.componentcount;
a:=0;
sf:=0;
if not(fileexists(savedialog.filename))then begin
sf:=1;
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sf:=1;
end;

sl.add('program '+lefto(extractfilename(savedialog.filename),'.')+';');
sl.add('uses messages,sysutils,wintypes;');
sl.add('var msg:tmsg;');
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+': hwnd;');
a:=a+1;
end;
sl.add('var WindowTitle: array[0..79] of Char;');
sl.add('const');
sl.add('ScreenSize: TPoint = (X: 80; Y: 25);');
sl.add('CrtWindow: HWnd = 0;');
sl.add('Created: Boolean = False;');
sl.add('var');
sl.add('ScreenBuffer: PChar;');
sl.add('procedure WindowCreate;begin');
sl.add('Created := True;GetMem(ScreenBuffer, ScreenSize.X * ScreenSize.Y);');
sl.add('end;');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint; stdcall; forward;');
sl.add('const');
sl.add('CrtClass: TWndClass = (');
sl.add('style: cs_HRedraw + cs_VRedraw;');
sl.add('lpfnWndProc: @crtWinProc;');
sl.add('cbClsExtra: 0;cbWndExtra: 0;');
sl.add('hInstance: 0;hIcon: 0;');
sl.add('hCursor: 0;hbrBackground: 6;');
sl.add('lpszMenuName: nil;lpszClassName: char(1));');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint; stdcall; begin');
sl.add('CrtWinProc := 0;');
sl.add('CrtWindow := Window;');
sl.add('case Message of');
sl.add('wm_Create: WindowCreate;');
sl.add('wm_Destroy: begin    PostQuitMessage(0); end;');
sl.add('else');
sl.add('CrtWinProc := DefWindowProc(Window, Message, WParam, LParam);');
sl.add('end;');
sl.add('end;');
sl.add('begin');
sl.add('if HPrevInst = 0 then begin');
sl.add('CrtClass.hInstance := HInstance;');
sl.add('CrtClass.hIcon := LoadIcon(0, idi_Application);');
sl.add('CrtClass.hCursor := LoadCursor(0, idc_Arrow);');
sl.add('CrtClass.hbrBackground := 6;');
sl.add('RegisterClass(CrtClass);');
sl.add('end;');
sl.add('GetModuleFileName(HInstance, WindowTitle, SizeOf(WindowTitle));');
{sl.add('OemToAnsi(WindowTitle, WindowTitle);');}
sl.add('if not Created then begin');
sl.add('CrtWindow := CreateWindow(');
sl.add('CrtClass.lpszClassName,');
sl.add(char(39)+application.mainform.caption+char(39)+',');
sl.add('ws_OverlappedWindow,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('0,0,HInstance,nil);');
{add components}
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+':= CreateWindow(');
{tbutton}
if(application.mainform.components[a] is tbutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON,');

end else
if(application.mainform.components[a] is tedit)then begin
sl.add(char(39)+'edit'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');

end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_CHECKBOX,');

end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_RADIOBUTTON,');
end else

if(application.mainform.components[a] is tlistbox)then begin
sl.add(char(39)+'listbox'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+LBS_HASSTRINGS+WS_BORDER,');
end;

sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('crtwindow,2,hInstance,nil);');

a:=a+1;
end;



sl.add('ShowWindow(CrtWindow, CmdShow);');
sl.add('end;');
sl.add('while GetMessage(msg, 0, 0, 0) do begin');
{add messes}

a:=0;
while a<comp do begin
sl.add('IF(msg.hwnd=hwnd'+inttostr(a)+')THEN begin');
sl.add('IF(msg.message=WM_LBUTTONUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_LBUTTONDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_MOUSEMOVE)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('END;');

sl.add('END;');
a:=a+1;
end;



sl.add('TranslateMessage(msg);');
sl.add('DispatchMessage(msg);');
sl.add('end;');
sl.add('Halt(msg.wParam);');


sl.add('end.');


if(sf=1)then begin
sl.savetofile(savedialog.filename);
end;
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;

end;
sl.free;
end;




procedure TTabbedDlg.watcomClick(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=3;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin

if(extractfileext(savedialog.filename)='.C')then begin
comp:=application.mainform.componentcount;
a:=0;
sl.add('#include <windows.h>'+'#include <stdio.h>'+'#include <malloc.h>');
sl.add('typedef struct {char far *cmdline;} extra_data;');
sl.add('#define EXTRA_DATA_OFFSET       0');
sl.add('#define MENU_ABOUT              1');
sl.add('#define MENU_CMDSTR             2');
sl.add('#ifdef __WINDOWS_386__');
sl.add('#define _EXPORT');
sl.add('#else');
sl.add('#define _EXPORT __export');
sl.add('#endif');
sl.add('HINSTANCE       MyInstance;');
sl.add('static char     GenericClass[32]="GenericClass";');
sl.add('static char    gc2[32]="button";');
sl.add('long _EXPORT FAR PASCAL WindowProc( HWND, unsigned, UINT, LONG );');
sl.add('int PASCAL WinMain( HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline,int cmdshow ){');
sl.add('HWND hwnd;');
{insert component handles}
a:=0;
while (a<comp) do begin
sl.add('HWND hwnd'+inttostr(a)+';');
a:=a+1;
end;
sl.add('extra_data  *edata_ptr;');
sl.add('#ifdef __NT__');
sl.add('    typedef VOID (WINAPI *PFNICC)( VOID );HINSTANCE commctrl_inst; PFNICC icc;');
sl.add('#endif');
sl.add('MSG msg;');
sl.add('#ifdef __NT__');
sl.add('commctrl_inst = LoadLibrary( "comctl32.dll" );');
sl.add('if( commctrl_inst != NULL ) {');
sl.add('icc = (PFNICC)GetProcAddress( commctrl_inst, "InitCommonControls" );');
sl.add('if( icc != NULL ) {icc();}}');
sl.add('#endif');
sl.add('MyInstance = this_inst;');
sl.add('#ifdef __WINDOWS_386__');
sl.add('sprintf( GenericClass, "GenericClass%d", this_inst ); prev_inst = 0;');
sl.add('#endif');
sl.add('if( !prev_inst ) {');
sl.add('WNDCLASS wc;BOOL rc;wc.style = CS_HREDRAW | CS_VREDRAW;');
sl.add('wc.lpfnWndProc = (LPVOID) WindowProc;wc.cbClsExtra = 0;');
sl.add('wc.cbWndExtra = sizeof( DWORD );wc.hInstance = this_inst;');
sl.add('wc.hIcon = NULL;wc.hCursor = LoadCursor( NULL, IDC_ARROW );');
sl.add('wc.hbrBackground = 6;wc.lpszMenuName = "GenericMenu";');
sl.add('wc.lpszClassName = GenericClass;rc = RegisterClass( &wc );');
sl.add('if( ! rc ) return( FALSE );}');
sl.add('hwnd = CreateWindow(GenericClass,"'+application.mainform.caption+'",WS_OVERLAPPEDWINDOW,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('NULL,NULL,this_inst,NULL);');
{insert ctrls}
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+'= CreateWindow(');
if(application.mainform.components[a] is tbutton)then begin
sl.add('gc2,');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE,');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add('gc2,');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_RADIOBUTTON,');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add('gc2,');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_CHECKBOX,');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add('"listbox",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+LBS_HASSTRINGS+WS_BORDER,');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add('"edit",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');
end;
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hwnd,NULL,this_inst,NULL);');
a:=a+1;
end;

sl.add('if( !hwnd ) return( FALSE );');
sl.add('edata_ptr = malloc( sizeof( extra_data ) );');
sl.add('if( edata_ptr == NULL ) return( FALSE );');
sl.add('edata_ptr->cmdline = cmdline;');
sl.add('SetWindowLong( hwnd, EXTRA_DATA_OFFSET, (DWORD) edata_ptr );');
sl.add('ShowWindow( hwnd, cmdshow );UpdateWindow( hwnd );');
sl.add('while( GetMessage( &msg, NULL, 0, 0 ) ) {');

a:=0;
while a<comp do begin
if
((not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')))
then begin

sl.add('if(hwnd'+inttostr(a)+' == '+'msg.hwnd){');
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']='')then begin
sl.add('if(WM_LBUTTONUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']='')then begin
sl.add('if(WM_LBUTTONDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']='')then begin
sl.add('if(WM_KEYUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')then begin
sl.add('if(WM_KEYDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']+'}');
end;
sl.add('}');
end;
a:=a+1;
end;


sl.add('TranslateMessage( &msg );DispatchMessage( &msg );}');
sl.add('#ifdef __NT__');
sl.add('if( commctrl_inst != NULL ) {FreeLibrary( commctrl_inst );}');
sl.add('#endif');
sl.add('return( msg.wParam );}');
sl.add('LONG _EXPORT FAR PASCAL WindowProc( HWND hwnd, unsigned msg,UINT wparam, LONG lparam ){');
sl.add('extra_data  *edata_ptr;char buff[128];');
sl.add('switch( msg ) {');
sl.add('case WM_COMMAND:');
sl.add('switch( LOWORD( wparam ) ) {');
sl.add('case MENU_ABOUT:');
sl.add('break;');
sl.add('case MENU_CMDSTR:');
sl.add('edata_ptr = (extra_data *) GetWindowLong( hwnd,EXTRA_DATA_OFFSET );');
sl.add('#ifdef __NT__');
sl.add('sprintf( buff, "Command string was \"%s\"", edata_ptr->cmdline );');
sl.add('#else');
sl.add('sprintf( buff, "Command string was \"%Fs\"", edata_ptr->cmdline );');
sl.add('#endif');
sl.add('MessageBox( NULL, buff, "Program Information", MB_OK );break;}');
sl.add('break;');
sl.add('case WM_DESTROY:');
sl.add('PostQuitMessage( 0 );');
sl.add('break;');
sl.add('default:');
sl.add('return( DefWindowProc( hwnd, msg, wparam, lparam ) );}');
sl.add('return( 0L );}');

if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;


end;
end;

sl.free;
end;

procedure TTabbedDlg.Devpascal1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=1;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.PP')then begin
comp:=application.mainform.componentcount;
a:=0;
sf:=0;
if not(fileexists(savedialog.filename))then begin
sf:=1;
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sf:=1;
end;
sl.add('{$APPTYPE GUI}');
sl.add('{$MODE DELPHI}');
sl.add('program '+lefto(extractfilename(savedialog.filename),'.')+';');
sl.add('uses windows,strings;');
sl.add('var msg:tmsg;');
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+': hwnd;');
a:=a+1;
end;
sl.add('var WindowTitle: array[0..79] of Char;');
sl.add('const');
sl.add('ScreenSize: TPoint = (X: 80; Y: 25);');
sl.add('CrtWindow: HWnd = 0;');
sl.add('Created: Boolean = False;');
sl.add('var');
sl.add('ScreenBuffer: PChar;');
sl.add('procedure WindowCreate;begin');
sl.add('Created := True;GetMem(ScreenBuffer, ScreenSize.X * ScreenSize.Y);');
sl.add('end;');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint; stdcall; forward;');
sl.add('const');
sl.add('CrtClass: TWndClass = (');
sl.add('style: cs_HRedraw + cs_VRedraw;');
sl.add('lpfnWndProc: @crtWinProc;');
sl.add('cbClsExtra: 0;cbWndExtra: 0;');
sl.add('hInstance: 0;hIcon: 0;');
sl.add('hCursor: 0;hbrBackground: 6;');
sl.add('lpszMenuName: nil;lpszClassName: char(1));');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint; stdcall; begin');
sl.add('CrtWinProc := 0;');
sl.add('CrtWindow := Window;');
sl.add('case Message of');
sl.add('wm_Create: WindowCreate;');
sl.add('wm_Destroy: begin    PostQuitMessage(0); end;');
sl.add('else');
sl.add('CrtWinProc := DefWindowProc(Window, Message, WParam, LParam);');
sl.add('end;');
sl.add('end;');
sl.add('begin');
sl.add('if HPrevInst = 0 then begin');
sl.add('CrtClass.hInstance := HInstance;');
sl.add('CrtClass.hIcon := LoadIcon(0, idi_Application);');
sl.add('CrtClass.hCursor := LoadCursor(0, idc_Arrow);');
sl.add('CrtClass.hbrBackground := 6;');
sl.add('RegisterClass(CrtClass);');
sl.add('end;');
sl.add('GetModuleFileName(HInstance, WindowTitle, SizeOf(WindowTitle));');
{sl.add('OemToAnsi(WindowTitle, WindowTitle);');}
sl.add('if not Created then begin');
sl.add('CrtWindow := CreateWindow(');
sl.add('CrtClass.lpszClassName,');
sl.add(char(39)+application.mainform.caption+char(39)+',');
sl.add('ws_OverlappedWindow,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('0,0,HInstance,nil);');
{add components}
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+':= CreateWindow(');
{tbutton}
if(application.mainform.components[a] is tbutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON,');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add(char(39)+'edit'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_CHECKBOX,');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_RADIOBUTTON,');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add(char(39)+'listbox'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+LBS_HASSTRINGS+WS_BORDER,');
end;
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('crtwindow,2,hInstance,nil);');


a:=a+1;
end;



sl.add('ShowWindow(CrtWindow, CmdShow);');
sl.add('end;');
sl.add('while GetMessage(msg, 0, 0, 0) do begin');
{add messes}

a:=0;
while a<comp do begin
sl.add('IF(msg.hwnd=hwnd'+inttostr(a)+')THEN begin');
sl.add('IF(msg.message=WM_LBUTTONUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_LBUTTONDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_MOUSEMOVE)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('END;');

sl.add('END;');
a:=a+1;
end;



sl.add('TranslateMessage(msg);');
sl.add('DispatchMessage(msg);');
sl.add('end;');
sl.add('Halt(msg.wParam);');


sl.add('end.');


if(sf=1)then begin
sl.savetofile(savedialog.filename);
end;
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;

end;
sl.free;
end;

procedure TTabbedDlg.POW321Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=2;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
                               showmessage('pow 32');
if(extractfileext(savedialog.filename)='.MOD')then begin
comp:=application.mainform.componentcount;
a:=0;
sl.add('MODULE '+lefto((extractfilename(savedialog.filename)),'.')+';');
ob32(sl,el,comp);
sl.add('END '+lefto((extractfilename(savedialog.filename)),'.')+'.');

if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);

end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);

end;


end;
end;

sl.free;

end;

procedure TTabbedDlg.xblite1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=9;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin

if(extractfileext(savedialog.filename)='.X')then begin
comp:=application.mainform.componentcount;
a:=0;
{sl.add('PROGRAM "'+lefto((extractfilename(savedialog.filename)),'.')+'"');}
sl.add('VERSION	"0.0001"');
sl.add('IMPORT	"gdi32"');
sl.add('IMPORT  "user32"');
sl.add('IMPORT  "kernel32"');
sl.add('IMPORT	"xsx"');
sl.add('DECLARE FUNCTION  Entry ()');
sl.add('DECLARE FUNCTION  WndProc (hwnd, msg, wParam, lParam)');

sl.add('FUNCTION  Entry ()');
sl.add('STATIC	entry');
sl.add('STATIC MSG msg');
sl.add('STATIC hInst,className$');
sl.add('WNDCLASS wc');

sl.add('IF entry THEN RETURN');
sl.add('entry =  $$TRUE');

sl.add('hInst = GetModuleHandleA (0)');
sl.add('IFZ hInst THEN QUIT(0)');

sl.add('className$  = "PongDemo"');
sl.add('addrWndProc = &WndProc()');
sl.add('icon$ 			= "scrabble"');
sl.add('menu$ 			= ""');
sl.add('wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC');
sl.add('wc.lpfnWndProc     = addrWndProc');
sl.add('wc.cbClsExtra      = 0');
sl.add('wc.cbWndExtra      = 0');
sl.add('wc.hInstance       = hInst');
sl.add('wc.hIcon           = 0');
sl.add('wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)');
sl.add('wc.hbrBackground   = 6');
sl.add('wc.lpszMenuName    = 0');
sl.add('wc.lpszClassName   = &className$');
sl.add('');
sl.add('IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)');
sl.add('titleBar$  	= "'+application.mainform.caption+'"');
sl.add('style 		= $$WS_OVERLAPPEDWINDOW | $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC');
sl.add('w 		= '+inttostr(application.mainform.width));
sl.add('h 		= '+inttostr(application.mainform.height));
sl.add('x 		= '+inttostr(application.mainform.left));
sl.add('y 		= '+inttostr(application.mainform.top));
sl.add('#winMain = CreateWindowExA (0, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)');
a:=0;
while a<comp do begin
if(application.mainform.components[a] is tbutton)then begin
sl.add('className'+inttostr(a)+'$  = "button"');
sl.add('style'+inttostr(a)+' 	= $$WS_CHILD+$$WS_VISIBLE+$$BS_PUSHBUTTON');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add('className'+inttostr(a)+'$  = "button"');
sl.add('style'+inttostr(a)+' 	= $$WS_CHILD+$$BS_CHECKBOX+$$WS_VISIBLE');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add('className'+inttostr(a)+'$  = "button"');
sl.add('style'+inttostr(a)+' 	= $$WS_CHILD+$$BS_RADIOBUTTON+$$WS_VISIBLE');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add('className'+inttostr(a)+'$  = "edit"');
sl.add('style'+inttostr(a)+' 	= $$WS_CHILD+$$WS_VISIBLE+$$WS_BORDER');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add('className'+inttostr(a)+'$  = "listbox"');
sl.add('style'+inttostr(a)+' 	= $$WS_CHILD+$$WS_VISIBLE+$$WS_BORDER');
end;
sl.add('titleBar'+inttostr(a)+'$  	= "'+tbutton(application.mainform.components[a]).caption+'"');
sl.add('w'+inttostr(a)+' 		= '+inttostr(twincontrol(application.mainform.components[a]).width));
sl.add('h'+inttostr(a)+' 		= '+inttostr(twincontrol(application.mainform.components[a]).height));
sl.add('x'+inttostr(a)+' 		= '+inttostr(twincontrol(application.mainform.components[a]).left));
sl.add('y'+inttostr(a)+' 		= '+inttostr(twincontrol(application.mainform.components[a]).top));
sl.add('#winMain'+inttostr(a)+' = CreateWindowExA (0, &className'+inttostr(a)+'$, &titleBar'+inttostr(a)+
'$, style'+inttostr(a)+
', x'+inttostr(a)+', y'+inttostr(a)+', w'+inttostr(a)+', h'+inttostr(a)+', #winMain, 0, hInst, 0)');

a:=a+1;
end;


sl.add('ShowWindow (#winMain, $$SW_SHOWNORMAL)');
sl.add('IF LIBRARY(0) THEN RETURN	');
sl.add('DO');
sl.add('		ret = GetMessageA (&msg, 0, 0, 0)');
sl.add('SELECT CASE ret');
sl.add('CASE  0 : RETURN msg.wParam');
sl.add('CASE -1 : RETURN $$TRUE');
sl.add('CASE ELSE:');
{here}
a:=0;
while a<comp do begin
sl.add('IF(msg.hwnd=#winMain'+inttostr(a)+')THEN');
sl.add('IF(msg.message=$$WM_LBUTTONUP)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('END IF');
sl.add('IF(msg.message=$$WM_LBUTTONDOWN)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('END IF');
sl.add('IF(msg.message=$$WM_KEYUP)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('END IF');
sl.add('IF(msg.message=$$WM_KEYDOWN)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('END IF');
sl.add('IF(msg.message=$$WM_MOUSEMOVE)THEN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('END IF');




sl.add('END IF');
a:=a+1;
end;


sl.add('			TranslateMessage (&msg)');
sl.add('			DispatchMessageA (&msg)');
sl.add('END SELECT');
sl.add('LOOP');

sl.add('UnregisterClassA (&className$, hInst)');
sl.add('END FUNCTION');
sl.add('');
sl.add('');

sl.add('FUNCTION WndProc (hWnd, msg, wParam, lParam)');
sl.add('SHARED width, height, fRunning');
sl.add('SHARED hdc');
sl.add('SHARED GIANT freq, next_pc');
sl.add('SHARED fPerfCount');
sl.add('SELECT CASE msg');
sl.add('CASE $$WM_CREATE:');

sl.add('fRunning = $$TRUE');
sl.add('CASE $$WM_DESTROY:');

sl.add('fRunning = $$FALSE');
sl.add('PostQuitMessage (0)');
sl.add('CASE ELSE');
sl.add('RETURN DefWindowProcA (hWnd, msg, wParam, lParam)');
sl.add('END SELECT');
sl.add('END FUNCTION');
sl.add('END PROGRAM');





if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;
end;
end;
sl.free;
end;

procedure TTabbedDlg.Virtualpascal1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=7;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.DPR')then begin
comp:=application.mainform.componentcount;
a:=0;
sf:=0;
if not(fileexists(savedialog.filename))then begin
sf:=1;
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sf:=1;
end;

sl.add('program '+lefto(extractfilename(savedialog.filename),'.')+';');
sl.add('{&PmType PM}');
sl.add('{&Delphi+,H+}');
sl.add('uses messages,sysutils,wintypes;');
sl.add('var msg:tmsg;');
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+': hwnd;');
a:=a+1;
end;
sl.add('var WindowTitle: array[0..79] of Char;');
sl.add('const');
sl.add('ScreenSize: TPoint = (X: 80; Y: 25);');
sl.add('CrtWindow: HWnd = 0;');
sl.add('Created: Boolean = False;');
sl.add('var');
sl.add('ScreenBuffer: PChar;');
sl.add('procedure WindowCreate;begin');
sl.add('Created := True;GetMem(ScreenBuffer, ScreenSize.X * ScreenSize.Y);');
sl.add('end;');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint; stdcall;forward; ');
sl.add('const');
sl.add('CrtClass: TWndClass = (');
sl.add('style: cs_HRedraw + cs_VRedraw;');
sl.add('lpfnWndProc: @crtWinProc;');
sl.add('cbClsExtra: 0;cbWndExtra: 0;');
sl.add('hInstance: 0;hIcon: 0;');
sl.add('hCursor: 0;hbrBackground: 6;');
sl.add('lpszMenuName: nil;lpszClassName: char(1));');
sl.add('function CrtWinProc(Window: HWnd; Message, WParam: Word;LParam: Longint): Longint;  begin');
sl.add('CrtWinProc := 0;');
sl.add('CrtWindow := Window;');
sl.add('case Message of');
sl.add('wm_Create: WindowCreate;');
sl.add('wm_Destroy: begin    PostQuitMessage(0); end;');
sl.add('else');
sl.add('CrtWinProc := DefWindowProc(Window, Message, WParam, LParam);');
sl.add('end;');
sl.add('end;');
sl.add('begin');
sl.add('if HPrevInst = 0 then begin');
sl.add('CrtClass.hInstance := HInstance;');
sl.add('CrtClass.hIcon := LoadIcon(0, idi_Application);');
sl.add('CrtClass.hCursor := LoadCursor(0, idc_Arrow);');
sl.add('CrtClass.hbrBackground := 6;');
sl.add('RegisterClass(CrtClass);');
sl.add('end;');
sl.add('GetModuleFileName(HInstance, WindowTitle, SizeOf(WindowTitle));');
{sl.add('OemToAnsi(WindowTitle, WindowTitle);');}
sl.add('if not Created then begin');
sl.add('CrtWindow := CreateWindow(');
sl.add('CrtClass.lpszClassName,');
sl.add(char(39)+application.mainform.caption+char(39)+',');
sl.add('ws_OverlappedWindow,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('0,0,HInstance,nil);');
{add components}
a:=0;
while (a<comp) do begin
sl.add('hwnd'+inttostr(a)+':= CreateWindow(');
{tbutton}
if(application.mainform.components[a] is tbutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON,');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add(char(39)+'edit'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_CHECKBOX,');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add(char(39)+'button'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+BS_RADIOBUTTON,');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add(char(39)+'listbox'+char(39)+',');
sl.add(char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',');
sl.add('WS_VISIBLE+WS_CHILD+LBS_HASSTRINGS+WS_BORDER,');
end;
sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('crtwindow,2,hInstance,nil);');

a:=a+1;
end;



sl.add('ShowWindow(CrtWindow, CmdShow);');
sl.add('end;');
sl.add('while GetMessage(msg, 0, 0, 0) do begin');
{add messes}

a:=0;
while a<comp do begin
sl.add('IF(msg.hwnd=hwnd'+inttostr(a)+')THEN begin');
sl.add('IF(msg.message=WM_LBUTTONUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_LBUTTONDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYUP)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('END;');
sl.add('IF(msg.message=WM_KEYDOWN)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('END;');
sl.add('IF(msg.message=WM_MOUSEMOVE)THEN begin');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('END;');

sl.add('END;');
a:=a+1;
end;



sl.add('TranslateMessage(msg);');
sl.add('DispatchMessage(msg);');
sl.add('end;');
sl.add('Halt(msg.wParam);');


sl.add('end.');


if(sf=1)then begin
sl.savetofile(savedialog.filename);
end;
end;

end;
sl.free;
end;


procedure TTabbedDlg.fasmw1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
var ds,st,tt:string;
begin
savedialog.filterindex:=8;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
comp:=application.mainform.componentcount;
a:=0;
if(extractfileext(savedialog.filename)='.ASM')then begin
sl.add('format PE GUI');
sl.add('entry start');
sl.add('include '+char(39)+'win32ax.inc'+char(39));

sl.add('IDM_NEW   = 101');
sl.add('IDM_EXIT  = 102 ');

sl.add('section '+char(39)+'.data'+char(39)+' data readable writeable');
sl.add('_class TCHAR '+char(39)+'MINIPAD32'+char(39)+',0');
sl.add(' _edit TCHAR '+char(39)+'EDIT'+char(39)+',0 ');
sl.add(' _button TCHAR '+char(39)+'BUTTON'+char(39)+',0 ');
sl.add(' _listbox TCHAR '+char(39)+'LISTBOX'+char(39)+',0 ');
a:=0;
while a<comp do begin
sl.add(' _string'+inttostr(a)+' TCHAR '+char(39)+tbutton(application.mainform.components[a]).caption+char(39)+',0');
a:=a+1;
end;


sl.add('_title TCHAR '+char(39)+application.mainform.caption+char(39)+',0');
sl.add('_error TCHAR '+char(39)+'Startup failed.'+char(39)+',0');
sl.add('wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,6,NULL,_class');
sl.add('edithwnd dd ?');
{add your window handles}
a:=0;
while a<comp do begin
sl.add('hwnd'+inttostr(a)+' dd ?');
a:=a+1;
end;
sl.add('editfont dd ?');
sl.add('msg MSG');
sl.add('client RECT');
sl.add('section '+char(39)+'.code'+char(39)+' code readable executable ');
sl.add('');
sl.add('start:');
sl.add('invoke  GetModuleHandle,0 ');
sl.add('mov     [wc.hInstance],eax');
sl.add('invoke  LoadIcon,eax,17');
sl.add('mov     [wc.hIcon],eax');
sl.add('invoke  LoadCursor,0,IDC_ARROW');
sl.add('mov     [wc.hCursor],eax');
sl.add('invoke  RegisterClass,wc');
sl.add('test    eax,eax');
sl.add('jz      error');

sl.add('invoke  CreateWindowEx,0,_class,_title,WS_VISIBLE+WS_OVERLAPPEDWINDOW,'+
inttostr(application.mainform.left)+','+
inttostr(application.mainform.top)+',' +
inttostr(application.mainform.width)+','+
inttostr(application.mainform.height)+
',NULL,0,[wc.hInstance],NULL');
sl.add('test    eax,eax');
sl.add('jz      error');
sl.add('');
sl.add('msg_loop:');

sl.add('invoke  GetMessage,msg,NULL,0,0');



sl.add('cmp     eax,1 ');
sl.add('jb      end_loop  ');
sl.add('jne     msg_loop');

a:=0;
while a<comp do begin
sl.add('mov eax,[hwnd'+inttostr(a)+']');
sl.add('.if [msg.hwnd]=eax');

sl.add('.if [msg.message]=WM_LBUTTONUP');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']);
sl.add('.endif');

sl.add('.if [msg.message]=WM_LBUTTONDOWN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']);
sl.add('.endif');

sl.add('.if [msg.message]=WM_MOUSEMOVE');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_MOUSEMOVE']);
sl.add('.endif');

sl.add('.if [msg.message]=WM_KEYUP');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']);
sl.add('.endif');

sl.add('.if [msg.message]=WM_KEYDOWN');
sl.add(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']);
sl.add('.endif');

sl.add('.endif');


 a:=a+1;
end;

sl.add('invoke  TranslateMessage,msg');
sl.add('invoke  DispatchMessage,msg');
sl.add('jmp     msg_loop');



sl.add('');
sl.add('error:');
sl.add(' invoke  MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK  ');
sl.add('');
sl.add('end_loop:');
sl.add('invoke  ExitProcess,[msg.wParam]');
sl.add('proc WindowProc hwnd,wmsg,wparam,lparam  ');
sl.add('push    ebx esi edi   ');
sl.add('cmp     [wmsg],WM_CREATE');
sl.add('je      .wmcreate');
sl.add('cmp     [wmsg],WM_SIZE ');
sl.add('je      .wmsize ');
sl.add('cmp     [wmsg],WM_SETFOCUS ');
sl.add('je      .wmsetfocus ');
sl.add('cmp     [wmsg],WM_COMMAND ');
sl.add('je      .wmcommand');
sl.add('cmp     [wmsg],WM_DESTROY');
sl.add('je      .wmdestroy');
sl.add('cmp     [wmsg],WM_DESTROY');
sl.add('.defwndproc:');
sl.add('invoke  DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]  ');
sl.add('jmp     .finish');
sl.add('');
sl.add('.wmcreate:');
sl.add('invoke  GetClientRect,[hwnd],client');
sl.add('or      eax,eax');
 a:=0;
 while a<comp do begin
 st:='';
 if(application.mainform.components[a] is tbutton)then begin ds:='button'; end;
  if(application.mainform.components[a] is tedit)then begin ds:='edit';st:='+WS_BORDER'; end;
   if(application.mainform.components[a] is tlistbox)then begin ds:='listbox';st:='+WS_BORDER'; end;
    if(application.mainform.components[a] is tradiobutton)then begin ds:='button'; st:='+BS_RADIOBUTTON'; end;
     if(application.mainform.components[a] is tcheckbox)then begin ds:='button'; st:='+BS_CHECKBOX'; end;
sl.add('invoke  CreateWindowEx,0,_'+
ds
+','+
' _string'+inttostr(a)
+',WS_VISIBLE+WS_CHILD'+st+
','  +
inttostr(twincontrol(application.mainform.components[a]).left)+','+
inttostr(twincontrol(application.mainform.components[a]).top)+','+
inttostr(twincontrol(application.mainform.components[a]).width)+','+
inttostr(twincontrol(application.mainform.components[a]).height)+','+
'[hwnd],0,[wc.hInstance],NULL');
sl.add('jz      .failed');
sl.add('mov     [hwnd'+inttostr(a)+'],eax');
a:=a+1;
     end;


sl.add('or      eax,eax');
sl.add('jz      .failed');

sl.add('xor     eax,eax');
sl.add('jmp     .finish');
sl.add('');
sl.add('.failed:');
sl.add('or      eax,-1');
sl.add('jmp     .finish');
sl.add('');
sl.add('.wmsize:');
sl.add('invoke  GetClientRect,[hwnd],client');
sl.add('invoke  MoveWindow,[edithwnd],[client.left],[client.top],[client.right],[client.bottom],TRUE');
sl.add('xor     eax,eax');
sl.add('jmp     .finish');
sl.add('');
sl.add('.wmsetfocus:');
sl.add('invoke  SetFocus,[edithwnd]');
sl.add('xor     eax,eax');
sl.add('jmp     .finish');
sl.add('');
sl.add('.wmcommand: ');
sl.add('mov     eax,[wparam]');
sl.add('and     eax,0FFFFh');
sl.add('cmp     eax,IDM_NEW');
sl.add('je      .new ');

sl.add('cmp     eax,IDM_EXIT');
sl.add('je      .wmdestroy');
sl.add('jmp     .defwndproc');
sl.add('');
sl.add('.new:');
sl.add('invoke  SendMessage,[edithwnd],WM_SETTEXT,0,0');
sl.add('jmp     .finish');
sl.add('');
sl.add('.about:');

sl.add('jmp     .finish');
sl.add('');
sl.add('.wmdestroy:');

sl.add('invoke  PostQuitMessage,0');
sl.add('xor     eax,eax');
sl.add('');
sl.add('.finish:');
sl.add('pop     edi esi ebx');
sl.add('ret');
sl.add('endp ');
sl.add('');
sl.add('section '+char(39)+'.idata'+char(39)+' import data readable writeable');
sl.add('library kernel,'+char(39)+'KERNEL32.DLL'+char(39)+',\');
sl.add('user,'+char(39)+'USER32.DLL'+char(39)+',\');
sl.add('gdi,'+char(39)+'GDI32.DLL'+char(39));
sl.add('import kernel,\');
sl.add('GetModuleHandle,'+char(39)+'GetModuleHandleA'+char(39)+',\');
sl.add('ExitProcess,'+char(39)+'ExitProcess'+char(39)+'');
sl.add('import user,\');
sl.add('RegisterClass,'+char(39)+'RegisterClassA'+char(39)+',\');
sl.add('CreateWindowEx,'+char(39)+'CreateWindowExA'+char(39)+',\');
sl.add('DefWindowProc,'+char(39)+'DefWindowProcA'+char(39)+',\');
sl.add('SetWindowLong,'+char(39)+'SetWindowLongA'+char(39)+',\ ');
sl.add('RedrawWindow,'+char(39)+'RedrawWindow'+char(39)+',\');
sl.add('GetMessage,'+char(39)+'GetMessageA'+char(39)+',\');
sl.add('TranslateMessage,'+char(39)+'TranslateMessage'+char(39)+',\');
sl.add('DispatchMessage,'+char(39)+'DispatchMessageA'+char(39)+',\ ');
sl.add('SendMessage,'+char(39)+'SendMessageA'+char(39)+',\');
sl.add('LoadCursor,'+char(39)+'LoadCursorA'+char(39)+',\');
sl.add('LoadIcon,'+char(39)+'LoadIconA'+char(39)+',\');
sl.add('LoadMenu,'+char(39)+'LoadMenuA'+char(39)+',\');
sl.add('GetClientRect,'+char(39)+'GetClientRect'+char(39)+',\');
sl.add('MoveWindow,'+char(39)+'MoveWindow'+char(39)+',\');
sl.add('SetFocus,'+char(39)+'SetFocus'+char(39)+',\');
sl.add('MessageBox,'+char(39)+'MessageBoxA'+char(39)+',\');
sl.add('PostQuitMessage,'+char(39)+'PostQuitMessage'+char(39)+'');
sl.add('import gdi,\');
sl.add('CreateFont,'+char(39)+'CreateFontA'+char(39)+',\');
sl.add('DeleteObject,'+char(39)+'DeleteObject'+char(39)+'');
sl.add('section '+char(39)+'.rsrc'+char(39)+' resource data readable');


sl.add(' versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\');
sl.add(char(39)+'FileDescription'+char(39)+','+char(39)+'MiniPad - example program'+char(39)+',\');
sl.add(char(39)+'LegalCopyrigh'+char(39)+','+char(39)+'No rights reserved'+char(39)+',\');
sl.add(char(39)+'FileVersion'+char(39)+','+char(39)+'1.0'+char(39)+',\');
sl.add(char(39)+'ProductVersion'+char(39)+','+char(39)+'MINIPAD.EXE'+char(39));
sl.add('section '+char(39)+'.reloc'+char(39)+' fixups data readable discardable       ; needed for Win32s');


if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;
end;
end;
sl.free;

end;

procedure TTabbedDlg.msvc1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=3;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.C')then begin
comp:=application.mainform.componentcount;
a:=0;
sl.add('#include "windows.h"');
sl.add('int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);');
sl.add('long CALLBACK __export MainWndProc(HWND, UINT, WPARAM, LPARAM);');
sl.add('HANDLE hInst;');
sl.add('int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)');
sl.add('HANDLE hInstance;HANDLE hPrevInstance;LPSTR lpCmdLine;');
sl.add('int nCmdShow;');
sl.add('{');
sl.add('MSG msg;');
sl.add('WNDCLASS  wc;');
sl.add('HWND hWnd;');
a:=0;
while a<comp do begin
sl.add('HWND hWnd'+inttostr(a)+';');
a:=a+1;
end;
sl.add('if (!hPrevInstance)');
sl.add('wc.style = NULL;');
sl.add('wc.lpfnWndProc = MainWndProc;');
sl.add('wc.cbClsExtra = 0;');
sl.add('wc.cbWndExtra = 0;');
sl.add('wc.hInstance = hInstance;');
sl.add('wc.hIcon = 0;');
sl.add('wc.hCursor = 0;');
sl.add('wc.hbrBackground = 6;');
sl.add('wc.lpszMenuName =  0;');
sl.add('wc.lpszClassName = "GenericWClass";');
sl.add('if (!(RegisterClass(&wc)))');
sl.add('return (FALSE);');
sl.add('hWnd = CreateWindow(');
sl.add('"GenericWClass",');

sl.add('"'+application.mainform.caption+'",');
sl.add('WS_OVERLAPPEDWINDOW,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('NULL,NULL,hInstance,NULL);');
sl.add('if (!hWnd) return (FALSE);');
a:=0;
while a<comp do begin
sl.add('hWnd'+inttostr(a)+'= CreateWindow(');

if(application.mainform.components[a] is tbutton)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE,');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_RADIOBUTTON,');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_CHECKBOX,');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add('"listbox",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+LBS_HASSTRINGS+WS_BORDER,');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add('"edit",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');
end;


sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,');
sl.add('NULL,hInstance,NULL);');
a:=a+1;
end;
sl.add('ShowWindow(hWnd, nCmdShow);');
sl.add('UpdateWindow(hWnd);');
sl.add('while (GetMessage(&msg,NULL,NULL,NULL)){');


a:=0;
while a<comp do begin
if
((not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')))
then begin

sl.add('if(hWnd'+inttostr(a)+' == '+'msg.hwnd){');
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']='')then begin
sl.add('if(WM_LBUTTONUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']='')then begin
sl.add('if(WM_LBUTTONDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']='')then begin
sl.add('if(WM_KEYUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')then begin
sl.add('if(WM_KEYDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']+'}');
end;

sl.add('}');

end;
a:=a+1;
end;





sl.add('TranslateMessage(&msg);DispatchMessage(&msg);');
sl.add('}');
sl.add('return (msg.wParam);');
sl.add('}');

sl.add('long CALLBACK __export MainWndProc(hWnd, message, wParam, lParam)');
sl.add('HWND hWnd;UINT message;WPARAM wParam;LPARAM lParam;');
sl.add('{');
sl.add('switch (message)');
sl.add('{');

sl.add('case WM_DESTROY:');
sl.add('PostQuitMessage(0);');
sl.add('break;');
sl.add('default:');
sl.add('return (DefWindowProc(hWnd, message, wParam, lParam));');
sl.add('}');
sl.add('return (NULL);');
sl.add('}');

if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;


end;
end;
sl.free;
end;




procedure TTabbedDlg.tpw1Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
comp:=application.mainform.componentcount;
savedialog.filterindex:=10;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.PAS')then begin
sl.add('program '+lefto(extractfilename(savedialog.filename),'.')+';');
tpw(sl,el,comp);


if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);

end;


end;
end;

sl.free;
end;

procedure TTabbedDlg.msvc2Click(Sender: TObject);
var a,comp:longint;
Instance: TControl;
sl:tstrings;
var sf:byte;
begin
savedialog.filterindex:=3;
savedialog.filename:='';
sl:=tstringlist.create;
savedialog.execute;
if not(savedialog.filename='')then begin
if(extractfileext(savedialog.filename)='.C')then begin
comp:=application.mainform.componentcount;
a:=0;

sl.add('#include <windows.h>');
sl.add('static char szWndClassName[] = "CHelloWorld" ;');
sl.add('LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)');
sl.add('{');
sl.add('switch (message)');
sl.add('{');
sl.add('case WM_DESTROY:');
sl.add('{');
sl.add('PostQuitMessage (0) ;');
sl.add('return 0;');
sl.add('}');
sl.add('default:');
sl.add('return DefWindowProc (hwnd, message, wParam, lParam) ;');
sl.add('}');
sl.add('}');
sl.add('int InitApplication(HINSTANCE hinstance)');
sl.add('{');
sl.add('WNDCLASS wc;   /* window class */');
sl.add('wc.style         = CS_HREDRAW | CS_VREDRAW ;');
sl.add('wc.lpfnWndProc   = (WNDPROC)WndProc ;');
sl.add('wc.cbClsExtra    = 0 ;');
sl.add('wc.cbWndExtra    = 0 ;');
sl.add('wc.hInstance     = hinstance ;');
sl.add('wc.hIcon         = NULL;');
sl.add('wc.hCursor       = 0;');
sl.add('wc.hbrBackground = 6;');
sl.add('wc.lpszMenuName  = NULL;');
sl.add('wc.lpszClassName = szWndClassName;');
sl.add('return RegisterClass(&wc);');
sl.add('}');
sl.add('int PASCAL WinMain (HINSTANCE hinstance, HINSTANCE hInstPrev, LPSTR lpszCmd, int nCmdShow)');
sl.add('{');
sl.add('MSG msg ;');
sl.add('HWND hWnd;');
while a<comp do begin
sl.add('HWND hWnd'+inttostr(a)+';');
a:=a+1;
end;


sl.add('if (!hInstPrev)');
sl.add('if (!InitApplication(hinstance)) return 0;');
sl.add('hWnd = CreateWindow(szWndClassName,');
sl.add('"'+application.mainform.caption+'",');
sl.add('WS_OVERLAPPEDWINDOW,');
sl.add(inttostr(application.mainform.left)+',');
sl.add(inttostr(application.mainform.top)+',');
sl.add(inttostr(application.mainform.width)+',');
sl.add(inttostr(application.mainform.height)+',');
sl.add('NULL,NULL,hinstance,NULL);');
a:=0;
while a<comp do begin
sl.add('hWnd'+inttostr(a)+'= CreateWindow(');

if(application.mainform.components[a] is tbutton)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE,');
end else
if(application.mainform.components[a] is tradiobutton)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_RADIOBUTTON,');
end else
if(application.mainform.components[a] is tcheckbox)then begin
sl.add('"button",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+BS_CHECKBOX,');
end else
if(application.mainform.components[a] is tlistbox)then begin
sl.add('"listbox",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_CHILD+WS_VISIBLE+LBS_HASSTRINGS+WS_BORDER,');
end else
if(application.mainform.components[a] is tedit)then begin
sl.add('"edit",');
sl.add('"'+tbutton(application.mainform.components[a]).caption+'",');
sl.add('WS_VISIBLE+WS_CHILD+ES_LEFT+WS_BORDER,');
end;


sl.add(inttostr(twincontrol(application.mainform.components[a]).left)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).top)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).width)+',');
sl.add(inttostr(twincontrol(application.mainform.components[a]).height)+',');
sl.add('hWnd,');
sl.add('NULL,hinstance,NULL);');
a:=a+1;
end;


sl.add('if (hWnd)');
sl.add('{ShowWindow(hWnd, nCmdShow);UpdateWindow(hWnd);}');
sl.add('while (GetMessage (&msg, NULL, 0, 0))');
sl.add('{');

a:=0;
while a<comp do begin
if
((not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']=''))
or(not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')))
then begin

sl.add('if(hWnd'+inttostr(a)+' == '+'msg.hwnd){');
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']='')then begin
sl.add('if(WM_LBUTTONUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']='')then begin
sl.add('if(WM_LBUTTONDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_LBUTTONDOWN']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']='')then begin
sl.add('if(WM_KEYUP == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYUP']+'}');
end;
if not(el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']='')then begin
sl.add('if(WM_KEYDOWN == msg.message){'+
el.values[inttostr(twincontrol(application.mainform.components[a]).handle)+',WM_KEYDOWN']+'}');
end;

sl.add('}');

end;
a:=a+1;
end;



sl.add('TranslateMessage(&msg) ;DispatchMessage(&msg);');
sl.add('}');
sl.add('return msg.wParam ;');
sl.add('}');

if not(fileexists(savedialog.filename))then begin
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end else begin
if(messagedlg('save over file?',mtwarning,mbokcancel,0)=mrok)then
sl.savetofile(savedialog.filename);
ShellExecute(handle,'open',Strtopchar(savedialog.filename) , nil,
  '',SW_SHOWNORMAL	);
end;


end;
end;
sl.free;
end;

end.
